#ifndef GLBOX_H
#define GLBOX_H

#include <math.h>
#include <qapplication.h>
#include <qgl.h>
#include <qtimer.h>
#include <qimage.h>
#include <qcursor.h>
#include "obj3d.h"
#include "principal.h"

#define MODE_NONE       0
#define MODE_FLAT       1
#define MODE_TEX_NEAR   2
#define MODE_TEX_LINEAR 3

class GLBox : public QGLWidget
  {
   Q_OBJECT

   public:
      void constructeur( void );
      GLBox( QWidget* parent, const char* name, const QGLWidget* shareWidget=0 );
      GLBox( const QGLFormat& format, QWidget* parent, const char* name, const QGLWidget* shareWidget=0 );
      ~GLBox();

      void set_theme( char *nom );
      void set_move( principal *p );
      void move_trans( bool m );
      void set_piece_pos( int piece, position p );
      void set_piece_maison( int piece );

      void place_RAZ();

  public slots:
      void set_RAZ();

      void setXRotation( int degrees );
      void setZRotation( int degrees );
      void set_scale( float size );

      void switch_mode( int mode );

  protected:
     void initializeGL();
     void paintGL();
     void resizeGL( int w, int h );

     void mousePressEvent(QMouseEvent* event);
     void mouseReleaseEvent(QMouseEvent* event);
     void mouseMoveEvent(QMouseEvent* event);

  private:
     GLfloat xRot, yRot, zRot, scale;
     bool bouttonL, bouttonM, bouttonR; // etat des bouttons
     GLint xR, yR, yM; // coord de clic
     int mode;

     int piece_depl;
     GLfloat piece_x, piece_y;

     obj3d *(obj[17]);
     obj3d *obj_plat;

     principal *princip;
     bool vue;

  private:
     int pick( GLint x, GLint y );
     void piece_maison( int piece );
};

#endif
