#ifndef interface_h
#define interface_h

#include <qgl.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qtimer.h>
#include <qmainwindow.h>
#include <qlistbox.h>
#include <qtabdialog.h>

#include "principal.h"
#include "glbox.h"

class QToolBar;

class Menu : public QMainWindow
{
  Q_OBJECT
    
    public:
  Menu();
  ~Menu();

  public slots:

  void agrandi();
  void diminu();
  
  void temp_machine();
  void init_machine();
  void init_humain();
  void temp_humain();
  void init_demo();
  void temp_demo();
  
  void charge();
  void save();
  void save_as();
  void undo();
  void redo();
  void temp_historique();
  void historique();
  void quitter();

  void theme_clas();
  void theme_moder();
  void initialise();
  
  void rotationG();
  void rotationD();
  void inclinaison_haute();
  void inclinaison_basse();
  
  void affiche_tex_lin();
  void affiche_tex_proche();
  void affiche_uni();
  void affiche_file_fer();
  
  void aide();
  void about();
  void aide_jeu();
  
  void katroclique();

private:
  QTabDialog *message_histo;
  GLBox* plateau;
  QWidget *w, *ma_bar;
  QStatusBar *contenu_barG, *contenu_barD;
  QString filename;
  QMenuBar *mon_menu; 
  QToolBar *fileTools;
  QTimer *timer_humain, *timer_machine, *timer_demo,*timer_historique ;
  int file_ferID, uniID, tex_procheID, tex_linID, theme_clasID, theme_moderID;
  bool isFile_fer, isUni, isTex_proche, isTex_lin, isTheme_clas, isTheme_moder;
  bool estHumain;
  QListBox *l;  
  int etape_actuel;

  QString filtre();
  void ordi_fin( QString );

 public:
  principal *p;
};


#endif












