#include "jeu.h"
#include "get_path.h"

jeu::jeu()
{
  int i,j;

  // INITIALISATION
  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
	plat[i][j]=NULL;

  libre[0]  = new piece(0 , false, true , false, false); // N G K P
  libre[1]  = new piece(1 , false, true , false, true ); // N G K C
  libre[2]  = new piece(2 , false, true , true , false); // N G R P
  libre[3]  = new piece(3 , false, true , true , true ); // N G R C
  libre[4]  = new piece(4 , true , true , false, false); // B G K P
  libre[5]  = new piece(5 , true , true , false, true ); // B G K C
  libre[6]  = new piece(6 , true , true , true , false); // B G R P
  libre[7]  = new piece(7 , true , true , true , true ); // B G R C
  libre[8]  = new piece(8 , false, false, false, false); // N p K P
  libre[9]  = new piece(9 , false, false, false, true ); // N p K C 
  libre[10] = new piece(10, false, false, true , false); // N p R P
  libre[11] = new piece(11, false, false, true , true ); // N p R C
  libre[12] = new piece(12, true , false, false, false); // B p K P
  libre[13] = new piece(13, true , false, false, true ); // B p K C
  libre[14] = new piece(14, true , false, true , false); // B p R P
  libre[15] = new piece(15, true , false, true , true ); // B p R C

  p_cour=NULL;

  cour=0;
  max=0;
  tetape[0].pnum=-1;

  nbTotalPi=16;
}

jeu::~jeu()
{
  int i,j;

  for(i=0;i<4;i++)
    for(j=0;j<4;j++)
      if(plat[i][j] != NULL)
	delete plat[i][j];

  for(i=0;i<16;i++)
    if(libre[i] != NULL)
      delete libre[i];

  if(p_cour!=NULL)
    delete p_cour;

}

bool jeu::blanches(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=true;
  else
    bool1=p1->blanche;

  if(p2==NULL)
    bool2=true;
  else
    bool2=p2->blanche;

  if(p3==NULL)
    bool3=true;
  else
    bool3=p3->blanche;

  if(p4==NULL)
    bool4=true;
  else
    bool4=p4->blanche;

  return(bool1 && bool2 && bool3 && bool4);
}

bool jeu::noires(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=false;
  else
    bool1=p1->blanche;

  if(p2==NULL)
    bool2=false;
  else
    bool2=p2->blanche;

  if(p3==NULL)
    bool3=false;
  else
    bool3=p3->blanche;

  if(p4==NULL)
    bool4=false;
  else
    bool4=p4->blanche;

  return(!(bool1 || bool2 || bool3 || bool4));
}

bool jeu::grandes(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=true;
  else
    bool1=p1->grande;

  if(p2==NULL)
    bool2=true;
  else
    bool2=p2->grande;

  if(p3==NULL)
    bool3=true;
  else
    bool3=p3->grande;

  if(p4==NULL)
    bool4=true;
  else
    bool4=p4->grande;

  return(bool1 && bool2 && bool3 && bool4);
}

bool jeu::petites(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=false;
  else
    bool1=p1->grande;

  if(p2==NULL)
    bool2=false;
  else
    bool2=p2->grande;

  if(p3==NULL)
    bool3=false;
  else
    bool3=p3->grande;

  if(p4==NULL)
    bool4=false;
  else
    bool4=p4->grande;

  return(!(bool1 || bool2 || bool3 || bool4));
}

bool jeu::rondes(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=true;
  else
    bool1=p1->ronde;

  if(p2==NULL)
    bool2=true;
  else
    bool2=p2->ronde;

  if(p3==NULL)
    bool3=true;
  else
    bool3=p3->ronde;

  if(p4==NULL)
    bool4=true;
  else
    bool4=p4->ronde;

  return(bool1 && bool2 && bool3 && bool4);
}

bool jeu::carrees(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=false;
  else
    bool1=p1->ronde;

  if(p2==NULL)
    bool2=false;
  else
    bool2=p2->ronde;

  if(p3==NULL)
    bool3=false;
  else
    bool3=p3->ronde;

  if(p4==NULL)
    bool4=false;
  else
    bool4=p4->ronde;

  return(!(bool1 || bool2 || bool3 || bool4));
}

bool jeu::creuses(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=true;
  else
    bool1=p1->creuse;

  if(p2==NULL)
    bool2=true;
  else
    bool2=p2->creuse;

  if(p3==NULL)
    bool3=true;
  else
    bool3=p3->creuse;

  if(p4==NULL)
    bool4=true;
  else
    bool4=p4->creuse;

  return(bool1 && bool2 && bool3 && bool4);
}

bool jeu::pleines(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  bool bool1,bool2,bool3,bool4;

  if(p1==NULL)
    bool1=false; /* pourra etre utile pour l'intelligence artificielle,
		    mais finallement inutile, puisque non utilis par par le IA
		 */
  else
    bool1=p1->creuse;

  if(p2==NULL)
    bool2=false;
  else
    bool2=p2->creuse;

  if(p3==NULL)
    bool3=false;
  else
    bool3=p3->creuse;

  if(p4==NULL)
    bool4=false;
  else
    bool4=p4->creuse;

  return(!(bool1 || bool2 || bool3 || bool4));
}

bool jeu::quatreidentique(piece* p1,piece* p2,piece* p3,piece* p4) const
{
  return(blanches(p1,p2,p3,p4) || noires(p1,p2,p3,p4)  ||
	 grandes(p1,p2,p3,p4)  || petites(p1,p2,p3,p4) ||
	 rondes(p1,p2,p3,p4)   || carrees(p1,p2,p3,p4) ||
	 creuses(p1,p2,p3,p4)  || pleines(p1,p2,p3,p4));
}

bool jeu::alignement(position p)const
{
  // HORIZONTAL
  if((plat[p.x][0]!=NULL) &&
     (plat[p.x][1]!=NULL) &&
     (plat[p.x][2]!=NULL) &&
     (plat[p.x][3]!=NULL))
    if(quatreidentique(plat[p.x][0],plat[p.x][1],plat[p.x][2],plat[p.x][3]))
      return(true);
  
  // VERTICAL
  if((plat[0][p.y]!=NULL) &&
     (plat[1][p.y]!=NULL) &&
     (plat[2][p.y]!=NULL) &&
     (plat[3][p.y]!=NULL))
    if(quatreidentique(plat[0][p.y],plat[1][p.y],plat[2][p.y],plat[3][p.y]))
      return(true);
  // DIAGONAL (0,0) \> (3,3)
  if(p.x == p.y)
    if((plat[0][0]!=NULL) &&
       (plat[1][1]!=NULL) &&
       (plat[2][2]!=NULL) &&
       (plat[3][3]!=NULL))
      if(quatreidentique(plat[0][0],plat[1][1],plat[2][2],plat[3][3]))
	return(true);
  
  // DIAGONAL (3,0) /> (0,3)
  if((p.x + p.y)==3)
    if((plat[0][3]!=NULL) &&
       (plat[1][2]!=NULL) &&
       (plat[2][1]!=NULL) &&
       (plat[3][0]!=NULL))
      if(quatreidentique(plat[0][3],plat[1][2],plat[2][1],plat[3][0]))
	return(true);

  return(false);
}

bool jeu::alignementKatro() const
{
  position pos;

  for(int i=0;i<4;i++)
    {
      pos.x=i;
      pos.y=i;
      if(alignement(pos))
	return(true);
    }
  pos.x=3;
  pos.y=0;
  return(alignement(pos));
}

bool jeu::placer(position p,piece* &pi)
{
  if(plat[p.x][p.y]==NULL)
    {
      plat[p.x][p.y] = pi;
      pi=NULL;
      tetape[cour].pos=p;
      tetape[cour].pnum= plat[p.x][p.y]->num;
      cour++;
      max=cour;
      if(cour<16)
	tetape[cour].pnum=-1;
      
      nbTotalPi--;
      return(true);
    }
  else
    return(false);
}

bool jeu::placerPourRecuperer(position p,piece* &pi)
{
  if(plat[p.x][p.y]==NULL)
    {
      plat[p.x][p.y] = pi;
      pi=NULL;
      tetape[cour].pos=p;
      tetape[cour].pnum= plat[p.x][p.y]->num;
      cour++;
      max=cour;
      
      nbTotalPi--;
      return(true);
    }
  else
    return(false);
}

bool jeu::undo(int &i)
{
  position p;

  if(p_cour!=NULL)
    {
      i=p_cour->num;
      libre[i]=p_cour;
      p_cour=NULL;
      return(true);
    }
  else
    {
      if(cour>0)
	{
	  cour--;
	  i=tetape[cour].pnum;
	  p=tetape[cour].pos;
	  p_cour=plat[p.x][p.y];
	  plat[p.x][p.y]=NULL;
	  i=-i-1;
	  nbTotalPi++;
	  return(true);
	}
    }
  return(false);
}

bool jeu::redo(position &p,int &i)
{
  if(max<16)
    {
      if(p_cour == NULL)
	{
	  if(tetape[cour].pnum!=-1)
	    {
	      i=tetape[cour].pnum;
	      p.x=-1;
	      p.y=-1;
	      p_cour=libre[i];
	      libre[i]=NULL;
	      i=-i-1;
	      return(true);
	    }
	}
      else
	{
	  if(cour<max)
	    {
	      i=p_cour->num;
	      p=tetape[cour].pos;
	      plat[p.x][p.y]=p_cour;
	      p_cour=NULL;
	      cour++;
	      nbTotalPi--;
	      return(true);
	    }
	}
    }
  return(false);
}



bool jeu::sauver(const char *nomfic, bool joueur, bool etat )
{
 FILE *file;

 file = fopen( nomfic, "w" );
 if( file == NULL )
   return(false);

 fprintf( file, "%i %i\n", joueur, etat );
 fprintf( file, "%i %i\n", cour, max );

 for(int i=0;i<max;i++)
   fprintf( file, "%i %i %i\n", tetape[i].pos.x, tetape[i].pos.y, tetape[i].pnum );

 if(max<16)
   fprintf( file, "%i %i %i\n", tetape[max].pos.x, tetape[max].pos.y, tetape[max].pnum );


 fclose( file );

 return(true);
}



bool jeu::recupererpartie(const char *nomfic, bool &joueur, bool &etat )
{
 FILE *file;
 int maximum,courant;
 file = fopen( nomfic, "r" );
 if( file == NULL )
   return(false);

 int joueur_, etat_;
 if(fscanf( file, "%i %i\n",&joueur_, &etat_ ) != 2)
   return(false);

 joueur = joueur_;
 etat = etat_;

 if(fscanf( file, "%i %i\n",&courant, &maximum ) != 2)
   return(false);

 for(int i=0;i<maximum;i++)
   {
     if(fscanf(file, "%i %i %i", &(tetape[i].pos.x), &(tetape[i].pos.y), &(tetape[i].pnum)) != 3)
       return(false);
   }

 if(maximum<16)
   {
     if(fscanf(file, "%i %i %i", &(tetape[maximum].pos.x), &(tetape[maximum].pos.y), &(tetape[maximum].pnum)) != 3)
       return(false);
   }

 for(int i=0;i<courant;i++)
   {
     if(!placerPourRecuperer( tetape[i].pos, libre[tetape[i].pnum] ))
	 return(false);
   }

 if(etat==false)
   if(tetape[cour].pnum!=-1)
     {
       p_cour=libre[tetape[cour].pnum];
       libre[tetape[cour].pnum]=NULL;
     }

 fclose( file );
 max=maximum;
 return(true);
}
