#ifndef jeu_h
#define jeu_h

#include "piece.h"
#include "definitiontypes.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

class jeu
{
 public:
  piece* plat[4][4];
  piece* libre[16];
  piece* p_cour;
  etape  tetape[16];
  int    max,cour;

  int nbBlanches;
  int nbGrandes;
  int nbRondes;
  int nbCreuses;
  int nbTotalPi;

  // CONSTRUCTEUR
  jeu();
  ~jeu();
  
  // METHODES
 private:
  bool blanches(piece*,piece*,piece*,piece*)const;
  bool noires(piece*,piece*,piece*,piece*)const;
  bool grandes(piece*,piece*,piece*,piece*)const;
  bool petites(piece*,piece*,piece*,piece*)const;
  bool rondes(piece*,piece*,piece*,piece*)const;
  bool carrees(piece*,piece*,piece*,piece*)const;
  bool creuses(piece*,piece*,piece*,piece*)const;
  bool pleines(piece*,piece*,piece*,piece*)const;
  bool quatreidentique(piece*,piece*,piece*,piece*) const;
  void afficherBLANCHE();
  void afficherGRANDE();
  void afficherRONDE();
  void afficherCREUSE();
  bool placerPourRecuperer(position ,piece* &);
  bool alignement(position)const;

 public:
  bool alignementKatro() const;
  bool placer(position,piece*&);
  bool undo(int &);
  bool redo(position &, int &);


  bool sauver(const char *,bool, bool);
  bool recupererpartie(const char *, bool &, bool &);

};
#endif
