#include "ordinateur.h"

#define LEVEL 8

#define PERDU -1
#define GAGNE  1

ordinateur::ordinateur() {}
ordinateur::~ordinateur() {}

bool ordinateur::donner( int &piece, jeu *le_jeu )
 {
  int pli=1;
  for( int i=0 ; i<16 ; i++ ) if( le_jeu->libre[i]==NULL ) pli=0;
  if( pli == 1 )
     piece = (int)( (float)random()/RAND_MAX * 16 );
   else
    {
     this->le_jeu = le_jeu;
     moi = true;

     copie_jeu();

     uchar p1, p2;

     if( donner_( p1, p2 ) == false ) return false;

     int v1=0, v2=1;
     v1 = jouerR(p1,0);
     if( p2 != 255 ) v2 = jouerR(p2,0);
                else { p2=p1; v1=v2; }

     if( p2 == 255 ) piece = p1;
                else piece = ( v1>v2 )? p1 : p2;

    }
  joueur::donner( piece, le_jeu );
  return true;
 }


bool ordinateur::jouer( position &pos, jeu *le_jeu )
 {
  this->le_jeu = le_jeu;
  moi = true;
  copie_jeu();

  int c1, c2;

  if( jouer_( le_jeu->p_cour->num, c1, c2 ) == false )
    {
     int v1=0, v2=1;
     {
       plat[c1/4][c1%4] = le_jeu->p_cour->num;
       piece_libre[le_jeu->p_cour->num] = 255;
       v1 = donnerR(0);
       plat[c1/4][c1%4] = 255;
       piece_libre[le_jeu->p_cour->num] = le_jeu->p_cour->num;
     }
     {
       plat[c2/4][c2%4] = le_jeu->p_cour->num;
       piece_libre[le_jeu->p_cour->num] = 255;
       v2 = donnerR(0);
       plat[c2/4][c2%4] = 255;
       piece_libre[le_jeu->p_cour->num] = le_jeu->p_cour->num;
     }

     if( v2 > v1 ) c1 = c2;
    }

  pos.x = c1/4;
  pos.y = c1%4;


  joueur::jouer( pos, le_jeu );
  return true;
 }


int ordinateur::donnerR( int level )
  {
   if( level >= LEVEL ) return 0;
   uchar p1, p2;
   if( donner_( p1, p2 ) == false )
     {
      return 0; // partie nulle
     }

   bool m=moi;
   int v1, v2;
   v1 = jouerR(p1,level+1);
   if( v1 != 0 ) return v1;
   moi=m;
   if( p2 != 255 ) v2 = jouerR(p2,level+1); else v2 = 0;
   if( v2 != 0 ) return v2;

   return v1+v2;
  }

int ordinateur::jouerR( uchar p, int level )
  {
   if( level >= LEVEL ) return 0;
   int c1, c2;

   if( jouer_( p, c1, c2 ) == true )
      return (moi)? GAGNE*(LEVEL-level) : PERDU*(LEVEL-level);

   bool m=moi;
   int v1, v2;
   {
    plat[c1/4][c1%4] = p;
    piece_libre[p] = 255;
    v1 = donnerR(level+1);
    plat[c1/4][c1%4] = 255;
    piece_libre[p] = p;
   }
   moi=m;
   {
    plat[c2/4][c2%4] = p;
    piece_libre[p] = 255;
    v2 = donnerR(level+1);
    plat[c2/4][c2%4] = 255;
    piece_libre[p] = p;
   }

   return v1+v2;
  }



bool ordinateur::donner_( uchar &p1, uchar &p2 )
 {
  elem t[16];
  int cont_pi_li=0;

  for( int piece=0 ; piece<16 ; piece++ )
    {
     if( piece_libre[piece] != 255 )
       {
        cont_pi_li++;
        t[piece].val = 0;
        for( int i=0 ; i<4 ; i++ )
           for( int j=0 ; j<4 ; j++ )
              if( plat[i][j] == 255 )
              {
                 t[piece].val += valeur( piece, i, j, 300 );
              }
       }
      else
        t[piece].val = INT_MAX;
     t[piece].i = piece;
    }

  if( cont_pi_li == 0 )
    {
     moi = ! moi;
     return false;
    }
  if( cont_pi_li == 1 )
    for( int i=0 ; i<16 ; i++ )
       if( piece_libre[i]!=255 )
         {
          p1=i;
          p2=255;
          moi = ! moi;
          return true;
         }

  qsort( t, 16, sizeof(elem), compar );

  p1=t[0].i;
  p2=t[1].i;

  moi = ! moi;
  return true;
}

bool ordinateur::jouer_( uchar p, int &c1, int &c2 )
 {
  elem pl[16];
  for( int i=0 ; i<4 ; i++ )
    for( int j=0 ; j<4 ; j++ )
      {
	if( plat[i][j] == 255 )
	  {
	    int v = valeur( p, i, j, 0 );
	    if( v == 0 ) //position gagnante
	      {
		c1 = c2 =i*4+j;
 		return true;
	      }
             else
	    pl[i*4+j].val = v;
	  }
	else
	  pl[i*4+j].val = INT_MAX;
	pl[i*4+j].i = i*4+j;
      }

  qsort( pl, 16, sizeof(elem), compar );

  c1 = pl[0].i;
  c2 = pl[1].i;

  return false;
 }


#define NEG(n) (15-n)
#define XOR(a,b) ( (a|b)&(NEG(a)|NEG(b)) )

int ordinateur::valeur( uchar p, int i, int j, int mode )
  {
   int score = 0;
   int n;
   uchar v;

   n=1; v=15;
   for( int a=0 ; a<4 ; a++ )
      if( plat[i][a] != 255 )
        {
         v = (uchar)NEG( (uchar)plat[i][a] xor (uchar)p ) & (uchar)v;
         n++;
        }

   if( n==4 && v!=0 && mode==0 ) return 0;
   if( v != 0 && n != 1 ) score += (n==4)? mode : 8<<n;
      else score += 8;

   n=1; v=15;
   for( int a=0 ; a<4 ; a++ )
      if( plat[a][j] != 255 )
        {
         v = NEG( plat[a][j] xor p ) & v;
         n++;
        }
   if( n==4 && v!=0 && mode==0 ) return 0;
   if( v != 0 && n != 1 ) score += (n==4)? mode : 8<<n;
      else score += 8;

   if( i==j ) // 1 diago
     {
      n=1; v=15;
      for( int a=0 ; a<4 ; a++ )
         if( plat[a][a] != 255 )
           {
            v = NEG( plat[a][a] xor p ) & v;
            n++;
           }
      if( n==4 && v!=0 ) return mode;
      if( v != 0 ) score += (n==4)? mode : 8<<n;
        else score += 8;
     }

   if( i+j==3 ) // 2 diago
     {
      n=1; v=15;
      for( int a=0 ; a<4 ; a++ )
         if( plat[a][3-a] != 255 )
           {
            v = NEG( plat[a][3-a] xor p ) & v;
            n++;
           }
      if( n==4 && v!=0 ) return mode;
      if( v != 0 ) score += (n==4)? mode : 8<<n;
        else score += 8;
     }

   if( i!=j && i+j!=3 ) return score * (3/2);
                   else return score;
  }

void ordinateur::copie_jeu()
  {
   for( int i=0 ; i<16 ; i++ )
      piece_libre[i] = (le_jeu->libre[i]==NULL)? 255 : le_jeu->libre[i]->num;
   for( int i=0 ; i<4 ; i++ )
      for( int j=0 ; j<4 ; j++ )
         plat[i][j] = (le_jeu->plat[i][j]==NULL)? 255 : le_jeu->plat[i][j]->num;
  }

int compar( const void *e1, const void *e2 )
  {
   return ( ( (elem*)e1)->val==((elem*)e2)->val )? 0 : ((  (elem*)e1)->val>((elem*)e2)->val )? 1 : -1;
  }
