#include "principal.h"

principal::principal(int mode)
{
  game = new jeu();

  etatDonner = true;
  tour_joueur = (int) ( (float)random()/RAND_MAX + 0.5);

  switch(mode)
    {
    case 0:
      pl[0]=new humain();
      pl[1]=new humain();
      break;
    case 1:
      pl[0]=new ordinateur();
      pl[1]=new humain();
      break;
    default:
      pl[0]=new ordinateur();
      pl[1]=new ordinateur();
    }
}

principal::~principal()
{
  if(pl[0]!=NULL) delete pl[0];
  if(pl[1]!=NULL) delete pl[1];
  if(game!=NULL) delete game;
}


bool principal::donner(int num)
{
  return(pl[tour_joueur]->donner(num,game));
}

bool principal::donner2(position pos)
{
  if( game->p_cour!=NULL )
    {
      if( (pos.x==-1) && (pos.y==-1) )
	{
          changerJoueur();
	  etatDonner = !etatDonner;
	  return(true);
	}
      else
	{
	  game->libre[ game->p_cour->num ] = game->p_cour;
	  game->p_cour=NULL;
	}
    }

  return(false);
}

bool principal::jouer(int num)
{
  if( game->p_cour != NULL )
    return( num == game->p_cour->num );
  return(false);
}

bool principal::jouer2(position pos)
{
  if( (pos.x!=-1) && (pos.y!=-1) )
    {
      if( pl[tour_joueur]->jouer(pos,game) )
	{
	  etatDonner = !etatDonner;
	  return(true);
	}
    }
  return(false);
}

bool principal::appuyer(int num)
{
  if(etatDonner)
      return(donner(num));
  else
      return(jouer(num));
}

bool principal::lacher(position pos)
{
  if(etatDonner)
      return(donner2(pos));
  else
      return(jouer2(pos));
}

int principal::joueurNum()
{
  return( ! tour_joueur );
}


void principal::changerJoueur()
{
  tour_joueur = ! tour_joueur;
}

bool principal::undo( position &pos,int &n)
{
  if(game->undo(n))
    {
      if(n<0)
	{
	  pos.x=-1;
	  pos.y=-1;
	}
      else
	changerJoueur();

      etatDonner = !etatDonner;
      return(true);
    }
  return(false);
}

bool principal::redo(position &pos,int &n)
{
  if(game->redo(pos,n))
    {
      if(n<0) changerJoueur();
      etatDonner = !etatDonner;
      return(true);
    }
  return(false);
}

bool principal::sauver(const char *s)
{
  if( etatDonner )
    return(game->sauver(s, tour_joueur, etatDonner) );
  else
    return(game->sauver(s, tour_joueur, etatDonner) );
}

bool principal::recupererpartie(const char *s)
{
  return game->recupererpartie(s,tour_joueur,etatDonner);
}

bool principal::finPartie()
{
  return(game->nbTotalPi == 0);
}

bool principal::alignementKatro()
{
  return(game->alignementKatro());
}


bool principal::aide(int &pi, position &pos)
  {
   bool tj = tour_joueur;

   joueur *tmp = pl[tj];
   pl[tj] = new ordinateur();


   bool b = tour_de_AI( pi, pos );


   delete pl[tj];
   pl[tj] = tmp;


   return b;
  }


bool principal::tour_de_AI(int &pi, position &pos)
{
  if(pl[tour_joueur]->is_ordinateur())
    {
      if( etatDonner )
	{
	  pl[tour_joueur]->donner(pi,game);
	  pos.x=-1;
	  pos.y=-1;
          changerJoueur();
	}
      else
	{
	  pl[tour_joueur]->jouer(pos,game);
	  pi=game->plat[pos.x][pos.y]->num;
	}
      etatDonner = !etatDonner;
      return(true);
    }
  return(false);
}
